﻿import es
import langlib
import playerlib
import popuplib

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2010/language/"

addon = es.import_addon("soccer_mod_2010/admin/settings")

settings = ["default_name_t", "default_name_ct", "default_short_name_t", "default_short_name_ct"]

# ******************** Load ********************
def load():
	for item in settings:
		es.set("sm_match_%s" % (item), es.keygetvalue("soccer_mod_settings", "match", "%s" % (item)))

	create_popup()

	es.addons.registerSayFilter(filter)

# ******************** Create popup ********************
def create_popup():
	common = langlib.Strings(lang_dir + "popup_common.ini")
	texts = langlib.Strings(lang_dir + "admin/settings/popup_admin_settings_match_names.ini")

	popup = popuplib.create("sm_popup_admin_settings_match_names")

	popup.addline("SOCCER MOD %s" % (texts("title")))
	popup.addline(" ")

	for i in range(0, len(settings)):
		popup.addline("->%s. %s: %s" % (i + 1, texts(settings[i]), es.ServerVar("sm_match_%s" % (settings[i]))))
		popup.select(i + 1, change_setting)

	popup.addline(" ")
	popup.addline("->9. %s" % (common("back")))
	popup.addline(" ")
	popup.addline("->0. %s" % (common("close")))

	for i in range(5, 9):
		popup.submenu(i, "sm_popup_admin_settings_match_names")

	popup.submenu(9, "sm_popup_admin_settings_match")

# ******************** Popup choice ********************
def change_setting(userid, choice, popupid):
	messages = langlib.Strings(lang_dir + "admin/settings/messages_settings_match_names.ini")

	tokens = {}
	player = playerlib.getPlayer(userid)

	if es.exists("key", "sm_keygroup_set", player.steamid) == 0:
		es.keycreate("sm_keygroup_set", player.steamid)

	es.keysetvalue("sm_keygroup_set", player.steamid, "setting_type", "settings_match_%s" % (settings[choice - 1]))

	es.tell(userid, "#green", messages("type_%s" % (settings[choice - 1]), tokens, player.get("lang")))

# ******************** Events ********************
def filter(userid, text, teamonly):
	steamid = es.getplayersteamid(userid)
	if es.exists("key", "sm_keygroup_set", steamid) == 1:
		name = "sm_popup_admin_settings_match_names"

		type = es.keygetvalue("sm_keygroup_set", steamid, "setting_type")
		if type == "settings_match_default_name_t":
			addon.set_string(userid, text, "match_names", "match", "default_name_t", 25, name, 1)
			return (0, None, 0)
		elif type == "settings_match_default_name_ct":
			addon.set_string(userid, text, "match_names", "match", "default_name_ct", 25, name, 2)
			return (0, None, 0)
		elif type == "settings_match_default_short_name_t":
			addon.set_string(userid, text, "match_names", "match", "default_short_name_t", 5, name, 3)
			return (0, None, 0)
		elif type == "settings_match_default_short_name_ct":
			addon.set_string(userid, text, "match_names", "match", "default_short_name_ct", 5, name, 4)
			return (0, None, 0)
		else:
			return (userid, text, teamonly)
	else:
		return (userid, text, teamonly)

# ******************** Unload ********************
def unload():
	popuplib.delete("sm_popup_admin_settings_match_names")

	es.addons.unregisterSayFilter(filter)