﻿import es
import gamethread
import langlib
import playerlib
import popuplib
import random

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2010/language/"

popup = popuplib.create("sm_popup_admin_cap")

texts = langlib.Strings(lang_dir + "cap/popup_admin_cap.ini")
messages = langlib.Strings(lang_dir + "cap/messages_cap.ini")
messages_common = langlib.Strings(lang_dir + "messages_common.ini")

# ******************** Load ********************
def load():
	es.set("sm_cap_fight_weapon", "knife")
	es.set("sm_cap_fight_health", 100)
	es.set("sm_cap_fight_speed", 1.0)
	es.set("sm_cap_fight_jump", 0)

	load_variables()

	create_popup()

	es.load("soccer_mod_2010/cap/pick")
	es.load("soccer_mod_2010/cap/settings")

# ******************** Load variables ********************
def load_variables():
	es.set("sm_cap_fight_started", 0)
	es.set("sm_cap_fight_frozen", 0)

# ******************** Create popup ********************
def create_popup():
	common = langlib.Strings(lang_dir + "popup_common.ini")

	popup.addline("SOCCER MOD %s" % (texts("title")))
	popup.addline(" ")
	popup.addline("->1. %s" % (texts("spectator")))
	popup.addline("->2. %s" % (texts("random_player")))
	popup.addline("->3. %s" % (texts("start")))
	popup.addline("->4. %s: %s" % (texts("weapon"), es.ServerVar("sm_cap_fight_weapon")))
	popup.addline("->5. %s: %s" % (texts("health"), es.ServerVar("sm_cap_fight_health")))
	popup.addline("->6. %s: %s" % (texts("speed"), es.ServerVar("sm_cap_fight_speed")))
	popup.addline("->7. %s: %s" % (texts("jump"), es.ServerVar("sm_cap_fight_jump")))
	popup.addline(" ")
	popup.addline("->9. %s" % (common("back")))
	popup.addline(" ")
	popup.addline("->0. %s" % (common("close")))

	for i in range(1, 8):
		popup.select(i, popup_choice)

	popup.submenu(8, "sm_popup_admin_cap")
	popup.submenu(9, "sm_popup_admin")

# ******************** Events ********************
def es_map_start(event_var):
	load_variables()

def player_spawn(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.ServerVar("sm_cap_fight_started") == 1:
			player = playerlib.getPlayer(event_var["userid"])
			if player.team > 1:
				if es.ServerVar("sm_cap_fight_frozen") == 0:
					es.server.queuecmd("es_give %s weapon_%s" % (event_var["userid"], es.ServerVar("sm_cap_fight_weapon")))
					player.health = es.ServerVar("sm_cap_fight_health")
					player.setSpeed(es.ServerVar("sm_cap_fight_speed"))
				else:
					player.freeze(1)

def player_jump(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.ServerVar("sm_cap_fight_started") == 1:
			if es.ServerVar("sm_cap_fight_jump") > 0:
				player = playerlib.getPlayer(event_var["userid"])
				player.push(es.ServerVar("sm_cap_fight_jump"), es.ServerVar("sm_cap_fight_jump"))

def round_start(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.ServerVar("sm_cap_fight_started") == 1:
			load_variables()

def flashbang_detonate(event_var):
	give_weapon(event_var["userid"], "flashbang")

def hegrenade_detonate(event_var):
	give_weapon(event_var["userid"], "hegrenade")

def smokegrenade_detonate(event_var):
	give_weapon(event_var["userid"], "smokegrenade")

# ******************** Popup choice ********************
def popup_choice(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	if es.ServerVar("sm_match_started") == 0:
		if es.ServerVar("sm_cap_fight_started") == 0:
			tokens["name"] = player.name

			if choice > 4:
				if es.exists("key", "sm_keygroup_set", player.steamid) == 0:
					es.keycreate("sm_keygroup_set", player.steamid)

			if choice == 1:
				lang_msg("cap_start", tokens, 1)

				for ply in playerlib.getPlayerList("#human"):
					if ply.team > 1:
						es.server.queuecmd("es_changeteam %s 1" % (ply.userid))

					es.server.queuecmd('usermsg hudhint %s "%s"' % (ply.userid, messages("cap_start", tokens, ply.get("lang"))))

				lang_msg("spec", tokens, 0)

				popuplib.send("sm_popup_admin_cap", userid)

			elif choice == 2:
				ts = int(es.getplayercount(2))
				cts = int(es.getplayercount(3))

				if ts == cts:
					force_random_player(userid, 2)
				elif ts < cts:
					force_random_player(userid, 2)
				elif ts > cts:
					force_random_player(userid, 3)

				popuplib.send("sm_popup_admin_cap", userid)

			elif choice == 3:
				for ply in playerlib.getPlayerList("#alive"):
					ply.freeze(1)

				es.set("sm_cap_fight_started", 1)
				es.set("sm_cap_fight_frozen", 1)

				for ply in playerlib.getPlayerList("#human"):
					es.server.queuecmd('usermsg hudhint %s "%s"' % (ply.userid, messages("get_ready", tokens, ply.get("lang"))))

				lang_msg("fight_started", tokens)

				lang_msg("prepare_fight", tokens, 1)
				gamethread.delayed(1, lang_msg, ("prepare_fight", tokens, 1))
				gamethread.delayed(2, tell_all, ("| 3 |"))
				gamethread.delayed(3, tell_all, ("| 2 |"))
				gamethread.delayed(4, tell_all, ("| 1 |"))
				gamethread.delayed(5, lang_msg, ("fight", tokens, 1))

				gamethread.delayed(5, fight)

				popuplib.send("sm_popup_admin_cap", userid)

			elif choice == 4:
				name = "sm_popup_%s" % (userid)
				if popuplib.exists(name):
					popuplib.delete(name)

				myPopup = popuplib.easymenu(name, None, set_weapon)
				myPopup.settitle("Select a weapon for a cap fight")

				weapons = [
					"ak47",
					"aug",
					"awp",
					"deagle",
					"elite",
					"fiveseven",
					"flashbang",
					"g3sg1",
					"galil",
					"glock",
					"hegrenade",
					"knife",
					"m249",
					"m3",
					"m4a1",
					"mac10",
					"mp5navy",
					"p90",
					"p228",
					"scout",
					"sg550",
					"sg552",
					"smokegrenade",
					"tmp",
					"ump45",
					"xm1014"
				]
				for item in weapons:
					myPopup.addoption(item, item)

				myPopup.submenu(10, "sm_popup_admin_cap")

				popuplib.send(name, userid)

			elif choice == 5:
				es.keysetvalue("sm_keygroup_set", player.steamid, "setting_type", "cap_fight_health")
				es.tell(userid, "#green", messages("type_health", tokens, player.get("lang")))

			elif choice == 6:
				es.keysetvalue("sm_keygroup_set", player.steamid, "setting_type", "cap_fight_speed")
				es.tell(userid, "#green", messages("type_speed", tokens, player.get("lang")))

			elif choice == 7:
				es.keysetvalue("sm_keygroup_set", player.steamid, "setting_type", "cap_fight_jump")
				es.tell(userid, "#green", messages("type_jump", tokens, player.get("lang")))
		else:
			es.tell(userid, "#green", messages_common("no_option_cap", tokens, player.get("lang")))
			popuplib.send("sm_popup_admin_cap", userid)
	else:
		es.tell(userid, "#green", messages_common("no_option_match", tokens, player.get("lang")))
		popuplib.send("sm_popup_admin_cap", userid)

# ******************** Easymenu choice ********************
def set_weapon(userid, choice, keymenuname):
	name = "sm_popup_%s" % (userid)
	if popuplib.exists(name):
		popuplib.delete(name)

	tokens = {}
	player = playerlib.getPlayer(userid)

	es.set("sm_cap_fight_weapon", choice)

	tokens["value"] = choice
	tokens["name"] = player.name

	popup.modline(6, "->4. %s: %s" % (texts("weapon"), choice))

	lang_msg("set_weapon", tokens)

	popuplib.send("sm_popup_admin_cap", userid)

# ******************** Functions ********************
def lang_msg(text, tokens, center = 0, team = None):
	for player in playerlib.getPlayerList("#human"):
		if team != None:
			tokens["team"] = messages(team, tokens, player.get("lang"))
		if center == 0:
			es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))
		else:
			es.centertell(player.userid, messages(text, tokens, player.get("lang")))

def force_random_player(userid, team):
	tokens = {}
	player = playerlib.getPlayer(userid)
	myPlayerList = playerlib.getPlayerList("#spec,#human")

	length = len(myPlayerList)
	if length > 0:
		length -= 1
		if length > 0:
			number = random.randint(0, length)
		else:
			number = 0

		es.server.queuecmd("es_changeteam %s %s" % (myPlayerList[number], team))

		tokens["name"] = es.getplayername(userid)
		tokens["target"] = es.getplayername(myPlayerList[number])
		lang_msg("random_player", tokens, 0)
	else:
		es.tell(userid, "#green", messages("no_player_available", tokens, player.get("lang")))

def tell_all(message):
	for player in playerlib.getPlayerList("#human"):
		es.centertell(player.userid, message)

def fight():
	if es.ServerVar("sm_cap_fight_started") == 1:
		es.set("sm_cap_fight_frozen", 0)

		for player in playerlib.getPlayerList("#alive"):
			player.godmode(0)
			player.freeze(0)
			player.health = es.ServerVar("sm_cap_fight_health")
			player.setSpeed(es.ServerVar("sm_cap_fight_speed"))

			weapon = es.ServerVar("sm_cap_fight_weapon")
			if weapon != "knife":
				es.server.queuecmd("es_give %s weapon_%s" % (player.userid, weapon))

def give_weapon(userid, weapon):
	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.ServerVar("sm_cap_fight_started") == 1:
			if es.ServerVar("sm_cap_fight_frozen") == 0:
				player = playerlib.getPlayer(userid)
				if player.isdead == 0:
					if es.ServerVar("sm_cap_fight_weapon") == weapon:
						if player.getFB() == 0 or player.getHE() == 0 or player.getSG() == 0:
							es.server.queuecmd("es_give %s weapon_%s" % (userid, weapon))

def spec_all_vote():
	if es.ServerVar("sm_match_started") == 0:
		if es.ServerVar("sm_cap_fight_started") == 0:
			tokens = {}
			lang_msg("cap_start", tokens, 1)

			for ply in playerlib.getPlayerList("#human"):
				if ply.team > 1:
					es.server.queuecmd("es_changeteam %s 1" % (ply.userid))

				es.server.queuecmd('usermsg hudhint %s "%s"' % (ply.userid, messages("cap_start", tokens, ply.get("lang"))))

# ******************** Unload ********************
def unload():
	popuplib.delete("sm_popup_admin_cap")

	es.unload("soccer_mod_2010/cap/pick")
	es.unload("soccer_mod_2010/cap/settings")