﻿import cmdlib
import es

addon = es.import_addon("soccer_mod_2010/cfg")

# ******************** Load ********************
def load():
	es.set("sm_match_sound_round_start", "soccer_mod/match/kickoff.wav")
	es.set("sm_match_sound_round_end", "soccer_mod/match/wickedsick.mp3")
	es.set("sm_match_sound_period_end", "soccer_mod/match/halftime.wav")
	es.set("sm_match_sound_match_end", "soccer_mod/match/endmatch.wav")

	cmdlib.registerServerCommand("soccer_mod_match_sound_round_start", sound_round_start, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_sound_round_end", sound_round_end, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_sound_period_end", sound_period_end, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_sound_match_end", sound_match_end, "Server Command")

	es.set("sm_match_command_start", "!start")
	es.set("sm_match_command_pause", "!pause")
	es.set("sm_match_command_unpause", "!unpause")
	es.set("sm_match_command_stop", "!stop")
	es.set("sm_match_command_stats", "!stats")
	es.set("sm_match_command_stats_clear", "!stats")

	cmdlib.registerServerCommand("soccer_mod_match_command_start", command_start, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_command_pause", command_pause, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_command_unpause", command_unpause, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_command_stop", command_stop, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_command_stats", command_stats, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_command_stats_clear", command_stats_clear, "Server Command")

	es.server.cmd("exec soccer_mod/modules/match.cfg")

	addon.reg("sm_match_command_start", "soccer_mod_2010/match/cmd_start")
	addon.reg("sm_match_command_pause", "soccer_mod_2010/match/cmd_pause")
	addon.reg("sm_match_command_unpause", "soccer_mod_2010/match/cmd_unpause")
	addon.reg("sm_match_command_stop", "soccer_mod_2010/match/cmd_stop")
	addon.reg("sm_match_command_stats", "soccer_mod_2010/match/stats/cmd_stats")
	addon.reg("sm_match_command_stats_clear", "soccer_mod_2010/match/stats/ranking/cmd_stats_clear")

# ******************** Commands ********************
def sound_round_start(args):
	es.set("sm_match_sound_round_start", args[0])

def sound_round_end(args):
	es.set("sm_match_sound_round_end", args[0])

def sound_period_end(args):
	es.set("sm_match_sound_period_end", args[0])

def sound_match_end(args):
	es.set("sm_match_sound_match_end", args[0])

def command_start(args):
	es.set("sm_match_command_start", args[0])

def command_pause(args):
	es.set("sm_match_command_pause", args[0])

def command_unpause(args):
	es.set("sm_match_command_unpause", args[0])

def command_stop(args):
	es.set("sm_match_command_stop", args[0])

def command_stats(args):
	es.set("sm_match_command_stats", args[0])

def command_stats_clear(args):
	es.set("sm_match_command_stats_clear", args[0])

# ******************** Events ********************
def es_map_start(event_var):
	addon.unreg("sm_match_command_start")
	addon.unreg("sm_match_command_pause")
	addon.unreg("sm_match_command_unpause")
	addon.unreg("sm_match_command_stop")
	addon.unreg("sm_match_command_stats")
	addon.unreg("sm_match_command_stats_clear")

	es.server.cmd("exec soccer_mod/modules/match.cfg")

	addon.reg("sm_match_command_start", "soccer_mod_2010/match/cmd_start")
	addon.reg("sm_match_command_pause", "soccer_mod_2010/match/cmd_pause")
	addon.reg("sm_match_command_unpause", "soccer_mod_2010/match/cmd_unpause")
	addon.reg("sm_match_command_stop", "soccer_mod_2010/match/cmd_stop")
	addon.reg("sm_match_command_stats", "soccer_mod_2010/match/stats/cmd_stats")
	addon.reg("sm_match_command_stats_clear", "soccer_mod_2010/match/stats/ranking/cmd_stats_clear")

# ******************** Unload ********************
def unload():
	cmdlib.unregisterServerCommand("soccer_mod_match_sound_round_start")
	cmdlib.unregisterServerCommand("soccer_mod_match_sound_round_end")
	cmdlib.unregisterServerCommand("soccer_mod_match_sound_period_end")
	cmdlib.unregisterServerCommand("soccer_mod_match_sound_match_end")

	cmdlib.unregisterServerCommand("soccer_mod_match_command_start")
	cmdlib.unregisterServerCommand("soccer_mod_match_command_pause")
	cmdlib.unregisterServerCommand("soccer_mod_match_command_unpause")
	cmdlib.unregisterServerCommand("soccer_mod_match_command_stop")
	cmdlib.unregisterServerCommand("soccer_mod_match_command_stats")
	cmdlib.unregisterServerCommand("soccer_mod_match_command_stats_clear")

	addon.unreg("sm_match_command_start")
	addon.unreg("sm_match_command_pause")
	addon.unreg("sm_match_command_unpause")
	addon.unreg("sm_match_command_stop")
	addon.unreg("sm_match_command_stats")
	addon.unreg("sm_match_command_stats_clear")