﻿import es
import langlib
import playerlib
import popuplib
import random

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2010/language/"

messages = langlib.Strings(lang_dir + "match/messages_match_score.ini")

cheers = [
	"bot/whoo.wav",
	"bot/whoo2.wav",
	"bot/yesss.wav",
	"bot/yesss2.wav",
	"bot/and_thats_how_its_done.wav",
	"bot/enemy_down2.wav",
	"bot/good_job_team.wav",
	"bot/nice.wav",
	"bot/nice2.wav",
	"bot/nice_work_team.wav",
	"bot/oh_yea.wav",
	"bot/oh_yea2.wav",
	"bot/owned.wav",
	"bot/very_nice.wav",
	"bot/we_owned_them.wav",
	"bot/yea_baby.wav"
]

# ******************** Load ********************
def load():
	load_variables()

	create_popup()

# ******************** Load variables ********************
def load_variables():
	es.set("sm_match_score_t", 0)
	es.set("sm_match_score_ct", 0)

# ******************** Create popup ********************
def create_popup():
	common = langlib.Strings(lang_dir + "popup_common.ini")
	text = langlib.Strings(lang_dir + "match/popup_admin_match_score.ini")

	popup = popuplib.create("sm_popup_admin_match_score")

	popup.addline("SOCCER MOD %s" % (text("title")))
	popup.addline(" ")

	tokens = {}

	tokens["team"] = es.ServerVar("sm_match_name_t")
	popup.addline("->1. %s" % (text("add", tokens)))

	tokens["team"] = es.ServerVar("sm_match_name_t")
	popup.addline("->2. %s" % (text("remove", tokens)))

	tokens["team"] = es.ServerVar("sm_match_name_ct")
	popup.addline("->3. %s" % (text("add", tokens)))

	tokens["team"] = es.ServerVar("sm_match_name_ct")
	popup.addline("->4. %s" % (text("remove", tokens)))

	popup.addline("->5. %s" % (text("reset")))
	popup.addline(" ")
	popup.addline("->9. %s" % (common("back")))
	popup.addline(" ")
	popup.addline("->0. %s" % (common("close")))

	popup.select(1, add)
	popup.select(2, remove)
	popup.select(3, add)
	popup.select(4, remove)
	popup.select(5, reset)

	for i in range(6, 9):
		popup.submenu(i, "sm_popup_admin_match_score")

	popup.submenu(9, "sm_popup_admin_match")

# ******************** Events ********************
def es_map_start(event_var):
	load_variables()

def round_start(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		es.server.queuecmd("score set #t %s" % (es.ServerVar("sm_match_score_t")))
		es.server.queuecmd("score set #ct %s" % (es.ServerVar("sm_match_score_ct")))

		if es.ServerVar("sm_match_sounds_on") == 1:
			es.cexec_all("playgamesound", es.ServerVar("sm_match_sound_round_start"))

def round_end(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		tokens = {}

		winner = int(event_var["winner"])

		name_t = es.ServerVar("sm_match_name_t")
		name_ct = es.ServerVar("sm_match_name_ct")

		short_name_t = es.ServerVar("sm_match_short_name_t")
		short_name_ct = es.ServerVar("sm_match_short_name_ct")

		score_t = es.ServerVar("sm_match_score_t")
		score_ct = es.ServerVar("sm_match_score_ct")

		swap = int(es.ServerVar("sm_match_swap_names_on"))
		seconds = es.ServerVar("sm_match_seconds")
		minutes = es.ServerVar("sm_match_minutes")

		if winner == 1:
			check = es.ServerVar("sm_match_started")
			if check == 0:
				load_variables()

		if winner == 2:
			score_t += 1
			es.set("sm_match_score_t", score_t)

			tokens["team"] = name_t

		if winner == 3:
			score_ct += 1
			es.set("sm_match_score_ct", score_ct)

			tokens["team"] = name_ct

		if int(es.ServerVar("sm_match_goal_scored")) == 1:
			if winner > 1:
				if es.ServerVar("sm_match_started") == 1:
					if swap == 0:
						score = ": %s %s - %s %s." % (short_name_t, score_t, score_ct, short_name_ct)
						if seconds < 10:
							tokens["time"] = "%s:0%s" % (minutes, seconds)
						else:
							tokens["time"] = "%s:%s" % (minutes, seconds)
					else:
						score = ": %s %s - %s %s." % (short_name_ct, score_ct, score_t, short_name_t)
						if seconds < 10:
							tokens["time"] = "%s:0%s" % (minutes, seconds)
						else:
							tokens["time"] = "%s:%s" % (minutes, seconds)

					message = messages("match_goal_scored", tokens) + score
				else:
					if swap == 0:
						score = ": %s %s - %s %s." % (short_name_t, score_t, score_ct, short_name_ct)
					else:
						score = ": %s %s - %s %s." % (short_name_ct, score_ct, score_t, short_name_t)
					message = messages("goal_scored", tokens) + score

				es.msg("#green", message)

		if es.ServerVar("golden_goal") == 1:
			if winner == 2:
				es.doblock("soccer_mod_2010/match/end/win_t")
			if winner == 3:
				es.doblock("soccer_mod_2010/match/end/win_ct")

			es.set("sm_match_started", 0)
			es.set("match_paused", 0)
			es.set("period_running", 0)
			es.set("period_break_running", 0)
			es.set("golden_goal", 0)
			es.set("seconds", 0)
			es.set("minutes", 0)
			es.set("period_break_running", 0)

		es.server.queuecmd("score set #t %s" % (score_t))
		es.server.queuecmd("score set #ct %s" % (score_ct))

		if es.ServerVar("sm_match_sounds_on") == 1:
			winner = int(event_var["winner"])
			if winner > 1:
				if winner == 2:
					for player in playerlib.getPlayerList("#alive,#t"):
						sound = random.randint(0, (len(cheers) - 1))
						es.emitsound("player", player.userid, cheers[sound], 1, 0.5)
				elif winner == 3:
					for player in playerlib.getPlayerList("#alive,#ct"):
						sound = random.randint(0, (len(cheers) - 1))
						es.emitsound("player", player.userid, cheers[sound], 1, 0.5)

				es.cexec_all("playgamesound", es.ServerVar("sm_match_sound_round_end"))

# ******************** Popup choice ********************
def add(userid, choice, popupid):
	if choice == 1:
		team = "t"
	elif choice == 3:
		team = "ct"

	score = es.ServerVar("sm_match_score_%s" % (team)) + 1
	es.set("sm_match_score_%s" % (team), score)

	es.server.queuecmd("score set #%s %s" % (team, score))

	tokens = {}
	tokens["name"] = es.getplayername(userid)
	tokens["team"] = es.ServerVar("sm_match_name_%s" % (team))
	lang_msg("goal_added", tokens)

	popuplib.send("sm_popup_admin_match_score", userid)

def remove(userid, choice, popupid):
	if choice == 2:
		team = "t"
	elif choice == 4:
		team = "ct"

	tokens = {}
	player = playerlib.getPlayer(userid)

	score = es.ServerVar("sm_match_score_%s" % (team))
	if score > 0:
		score -= 1
		es.set("sm_match_score_%s" % (team), score)

		es.server.queuecmd("score set #%s %s" % (team, score))

		tokens["name"] = es.getplayername(userid)
		tokens["team"] = es.ServerVar("sm_match_name_%s" % (team))
		lang_msg("goal_removed", tokens)
	else:
		es.tell(userid, "#green", messages("already_0", tokens, player.get("lang")))

	popuplib.send("sm_popup_admin_match_score", userid)

def reset(userid, choice, popupid):
	load_variables()

	es.server.queuecmd("score set #t 0")
	es.server.queuecmd("score set #ct 0")

	tokens = {}
	tokens["name"] = es.getplayername(userid)
	lang_msg("reset", tokens)

	popuplib.send("sm_popup_admin_match_score", userid)

# ******************** Functions ********************
def lang_msg(text, tokens):
	for player in playerlib.getPlayerList("#human"):
		es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))

# ******************** Unload ********************
def unload():
	popuplib.delete("sm_popup_admin_match_score")